package com.aures.mobile.app.assist;

import java.io.IOException;
import java.io.UnsupportedEncodingException;

import android.graphics.Typeface;

import com.aures.jpos.command.CPCLConst;
import com.aures.jpos.command.ESCPOSConst;
import com.aures.jpos.printer.CPCLPrinter;

public class CPCLSample2
{
	private CPCLPrinter cpclPrinter;
	private int paperType;
	
	public CPCLSample2()
	{
		cpclPrinter = new CPCLPrinter();
		paperType = CPCLConst.AURES_CPCL_LABEL;
	}
	
	public void selectGapPaper()
	{
		paperType = CPCLConst.AURES_CPCL_LABEL;
	}
	
	public void selectBlackMarkPaper()
	{
		paperType = CPCLConst.AURES_CPCL_BLACKMARK;
	}
	
	public void selectContinuousPaper()
	{
		paperType = CPCLConst.AURES_CPCL_CONTINUOUS;
	}
	
	public void barcodeTest(int count) throws UnsupportedEncodingException
    {
		cpclPrinter.setForm(0, 200, 200, 406, count);
		cpclPrinter.setMedia(paperType);
		
		// CODABAR
		cpclPrinter.setCPCLBarcode(0, 0, 0);
		cpclPrinter.printCPCLBarcode(CPCLConst.AURES_CPCL_0_ROTATION, CPCLConst.AURES_CPCL_BCS_CODABAR, 2, CPCLConst.AURES_CPCL_BCS_0RATIO, 30, 19, 45, "A37859B", 0);
		cpclPrinter.printCPCLText(0, 7, 0, 19, 18, "CODABAR", 0);
		// Code 39
		cpclPrinter.setCPCLBarcode(0, 0, 0);
		cpclPrinter.printCPCLBarcode(CPCLConst.AURES_CPCL_0_ROTATION, CPCLConst.AURES_CPCL_BCS_39, 2, CPCLConst.AURES_CPCL_BCS_1RATIO, 30, 19, 130, "0123456", 0);
		cpclPrinter.printCPCLText(0, 7, 0, 21, 103, "CODE 39", 0);
		// Code 93
		cpclPrinter.setCPCLBarcode(0, 0, 0);
		cpclPrinter.printCPCLBarcode(CPCLConst.AURES_CPCL_0_ROTATION, CPCLConst.AURES_CPCL_BCS_93, 2, CPCLConst.AURES_CPCL_BCS_1RATIO, 30, 19, 215, "0123456", 0);
		cpclPrinter.printCPCLText(0, 7, 0, 21, 180, "CODE 93", 0);
		// BARCODE 128 1 1 50 150 10 HORIZ.
		cpclPrinter.setCPCLBarcode(0, 0, 0);
		cpclPrinter.printCPCLBarcode(CPCLConst.AURES_CPCL_0_ROTATION, CPCLConst.AURES_CPCL_BCS_128, 2, CPCLConst.AURES_CPCL_BCS_1RATIO, 30, 19, 300, "A37859B", 0);
		cpclPrinter.printCPCLText(0, 7, 0, 21, 270, "CODE 128", 0);		
		// Print
		cpclPrinter.printForm();
    }
    
    public void barcode2DTest(int count) throws IOException
    {
    	cpclPrinter.setForm(0, 200, 200, 406, count);
		cpclPrinter.setMedia(paperType);
		
		cpclPrinter.printCPCL2DBarCode(0, CPCLConst.AURES_CPCL_BCS_PDF417, 80, 180, 2, 7, 2, 1, "AURES Technologies\r\nMobile Printer");
		cpclPrinter.printCPCL2DBarCode(0, CPCLConst.AURES_CPCL_BCS_QRCODE, 30, 50, 4, 0, 1, 0, "Test Print");
		cpclPrinter.printCPCL2DBarCode(0, CPCLConst.AURES_CPCL_BCS_QRCODE, 30, 200, 4, 0, 1, 0, "Test Print");

		cpclPrinter.printForm();
    }
    
    public void imageTest(int count) throws IOException
    {
    	cpclPrinter.setForm(0, 200, 200, 406, count);    	
		cpclPrinter.setMedia(paperType);
		
    	cpclPrinter.printBitmap("//sdcard//temp//test//sample_2.jpg", 1, 200);    	
    	cpclPrinter.printBitmap("//sdcard//temp//test//sample_3.jpg", 100, 200);    	
    	cpclPrinter.printBitmap("//sdcard//temp//test//sample_4.jpg", 120, 245);      	
    	cpclPrinter.printForm();    	
    }
        
    public void dmStamp(int count) throws IOException
    {
    	cpclPrinter.setForm(0, 200, 200, 406, count);
		cpclPrinter.setMedia(paperType);
		
		cpclPrinter.printBitmap("//sdcard//temp//test//danmark_windmill.jpg", 10, 10);		
		cpclPrinter.printBitmap("//sdcard//temp//test//denmark_flag.jpg", 222, 55);		
		cpclPrinter.setCPCLBarcode(0, 0, 0);
		cpclPrinter.printCPCLBarcode(CPCLConst.AURES_CPCL_0_ROTATION, CPCLConst.AURES_CPCL_BCS_128, 2, CPCLConst.AURES_CPCL_BCS_1RATIO, 30, 19, 290, "0123456", 1);
		cpclPrinter.printCPCLText(0, 0, 1, 21, 345, "Quantity 001", 1);
		cpclPrinter.printForm();
    }
   
	public void fontTest(int count) throws UnsupportedEncodingException
    {
		cpclPrinter.setForm(0, 200, 200, 406, count);
		cpclPrinter.setMedia(paperType);
		
		cpclPrinter.printCPCLText(0, 0, 0, 1, 1,   "FONT-0-0", 2);
		cpclPrinter.printCPCLText(0, 0, 1, 1, 50,  "FONT-0-1", 0);
		cpclPrinter.printCPCLText(0, 4, 0, 1, 100, "FONT-4-0", 0);
		cpclPrinter.printCPCLText(0, 4, 1, 1, 150,  "FONT-4-1", 0);
		cpclPrinter.printCPCLText(0, 4, 2, 1, 260,  "4-2", 0);
		// Print
		cpclPrinter.printForm();
    }
	    
	public void fontTypeTest(int count) throws UnsupportedEncodingException
    {
		cpclPrinter.setForm(0, 200, 200, 406, count);
		cpclPrinter.setMedia(paperType);
		
		// FONT 0,1,2,4,5,6,7
    	cpclPrinter.printCPCLText(0, 0, 0, 1, 1,   "ABCD1234", 0);
		cpclPrinter.printCPCLText(0, 1, 0, 1, 20,  "ABCD1234", 0);
		cpclPrinter.printCPCLText(0, 2, 0, 1, 70, "ABCD1234", 0);
		cpclPrinter.printCPCLText(0, 4, 0, 1, 100, "ABCD1234", 0);
		cpclPrinter.printCPCLText(0, 5, 0, 1, 150, "ABCD1234", 0);
		cpclPrinter.printCPCLText(0, 6, 0, 1, 200,  "ABCD1234", 0);
		cpclPrinter.printCPCLText(0, 7, 0, 1, 250,  "ABCD1234", 0);
		// Print
		cpclPrinter.printForm();
    }	
	
	public void multiLineTest(int count) throws UnsupportedEncodingException
	{
		String data = "ABCDEFGHIJKLMNOPQRSTUVWXYZ;0123456789!@#%^&*\r\n";
		StringBuffer sb = new StringBuffer();
		for(int i=0;i<16;i++)
		{
			sb.append(data);
		}
		
		cpclPrinter.setForm(0, 200, 200, 406, count);
		cpclPrinter.setMedia(paperType);
    	
		// MultiLine mode.
		cpclPrinter.setMultiLine(15);
		cpclPrinter.multiLineText(0, 0, 0, 10, 20);
		cpclPrinter.multiLineData(sb.toString());
		cpclPrinter.resetMultiLine();
		// Print
		cpclPrinter.printForm();		
	}
	
    public void printAndroidFont(int count) throws UnsupportedEncodingException
	{
    	int nLineWidth = 384;
    	String data = "Receipt";

    	try
		{
    		cpclPrinter.setForm(0, 200, 200, 406, count);
    		cpclPrinter.setMedia(paperType);

    		cpclPrinter.printAndroidFont(data, nLineWidth, 100, 0, ESCPOSConst.AURES_ALIGNMENT_CENTER);
    		cpclPrinter.printAndroidFont("Left Alignment", nLineWidth, 24, 120, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		cpclPrinter.printAndroidFont("Center Alignment", nLineWidth, 24, 150, ESCPOSConst.AURES_ALIGNMENT_CENTER);
    		cpclPrinter.printAndroidFont("Right Alignment", nLineWidth, 24, 180, ESCPOSConst.AURES_ALIGNMENT_RIGHT);

    		cpclPrinter.printAndroidFont(Typeface.SANS_SERIF, "SANS_SERIF : 1234iwIW", nLineWidth, 24, 210, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		cpclPrinter.printAndroidFont(Typeface.SERIF, "SERIF : 1234iwIW", nLineWidth, 24, 240, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		cpclPrinter.printAndroidFont(Typeface.MONOSPACE, "MONOSPACE : 1234iwIW", nLineWidth, 24, 270, ESCPOSConst.AURES_ALIGNMENT_LEFT);

    		// Print
    		cpclPrinter.printForm();		
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}	

    public void printMultilingualFont(int count) throws UnsupportedEncodingException
	{
    	int nLineWidth = 384;
    	String Koreandata = "?��?���?";
    	String Turkishdata = "Turkish(İ,Ş,Ğ)";
    	String Russiandata = "?�олучени�?";
    	String Arabicdata = "ا?��??�صا�?";
    	String Greekdata = "?�αραλαβ�?";
    	String Japanesedata = "?��?��?��";
    	String GB2312data = "?��?��";
    	String BIG5data = "?��?��";

    	try
		{
    		cpclPrinter.setForm(0, 200, 200, 1000, count);
    		cpclPrinter.setMedia(paperType);

    		cpclPrinter.printAndroidFont("Korean Font", nLineWidth, 24, 0, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		// Korean 100-dot size font in android device.
    		cpclPrinter.printAndroidFont(Koreandata, nLineWidth, 100, 30, ESCPOSConst.AURES_ALIGNMENT_CENTER);

    		cpclPrinter.printAndroidFont("Turkish Font", nLineWidth, 24, 140, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		// Turkish 50-dot size font in android device.
    		cpclPrinter.printAndroidFont(Turkishdata, nLineWidth, 50, 170, ESCPOSConst.AURES_ALIGNMENT_CENTER);

    		cpclPrinter.printAndroidFont("Russian Font", nLineWidth, 24, 230, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		// Russian 60-dot size font in android device.
    		cpclPrinter.printAndroidFont(Russiandata, nLineWidth, 60, 260, ESCPOSConst.AURES_ALIGNMENT_CENTER);

    		cpclPrinter.printAndroidFont("Arabic Font", nLineWidth, 24, 330, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		// Arabic 100-dot size font in android device.
    		cpclPrinter.printAndroidFont(Arabicdata, nLineWidth, 100, 360, ESCPOSConst.AURES_ALIGNMENT_CENTER);

    		cpclPrinter.printAndroidFont("Greek Font", nLineWidth, 24, 470, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		// Greek 60-dot size font in android device.
    		cpclPrinter.printAndroidFont(Greekdata, nLineWidth, 60, 500, ESCPOSConst.AURES_ALIGNMENT_CENTER);

    		cpclPrinter.printAndroidFont("Japanese Font", nLineWidth, 24, 570, ESCPOSConst.AURES_ALIGNMENT_LEFT);
        	// Japanese 100-dot size font in android device.
    		cpclPrinter.printAndroidFont(Japanesedata, nLineWidth, 100, 600, ESCPOSConst.AURES_ALIGNMENT_CENTER);

    		cpclPrinter.printAndroidFont("GB2312 Font", nLineWidth, 24, 710, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		// GB2312 100-dot size font in android device.
    		cpclPrinter.printAndroidFont(GB2312data, nLineWidth, 100, 740, ESCPOSConst.AURES_ALIGNMENT_CENTER);

    		cpclPrinter.printAndroidFont("BIG5 Font", nLineWidth, 24, 20, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		// BIG5 100-dot size font in android device.
    		cpclPrinter.printAndroidFont(BIG5data, nLineWidth, 100, 80, ESCPOSConst.AURES_ALIGNMENT_CENTER);

    		// Print
    		cpclPrinter.printForm();		
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}    
}
