package com.aures.mobile.app.assist;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.text.SimpleDateFormat;
import java.util.Date;

import android.graphics.Typeface;

import com.aures.jpos.command.CPCLConst;
import com.aures.jpos.command.ESCPOSConst;
import com.aures.jpos.printer.CPCLPrinter;

public class CPCLSample4
{
	protected CPCLPrinter cpclPrinter;
	private int paperType;
	
	public CPCLSample4()
	{
		cpclPrinter = new CPCLPrinter();
//		cpclPrinter = new CPCLPrinter("EUC-KR");
		paperType = CPCLConst.AURES_CPCL_CONTINUOUS;
	}
	
	public void selectGapPaper()
	{
		paperType = CPCLConst.AURES_CPCL_LABEL;
	}
	
	public void selectBlackMarkPaper()
	{
		paperType = CPCLConst.AURES_CPCL_BLACKMARK;
	}
	
	public void selectContinuousPaper()
	{
		paperType = CPCLConst.AURES_CPCL_CONTINUOUS;
	}
    
    public void image3(int count) throws IOException
    {
    	cpclPrinter.setForm(0, 200, 200, 576, count);
    	cpclPrinter.setMedia(paperType);
    	cpclPrinter.setCPCLBarcode(0, 2, 0);
		cpclPrinter.printBitmap("//sdcard//temp//test//Sewoo_bw_m.jpg", 1, 1);
//    	cpclPrinter.printCPCLImage("SEWOO.PCX", 1, 50);
		cpclPrinter.printBitmap("//sdcard//temp//test//car_s.jpg", 100, 140);
//		cpclPrinter.printCPCL2DBarCode(0, CPCLConst.AURES_CPCL_BCS_PDF417, 150, 440, 2, 7, 2, 1, "http://www.miniprinter.com");
		cpclPrinter.printCPCL2DBarCode(0, CPCLConst.AURES_CPCL_BCS_QRCODE, 150, 400, 5, 0, 1, 0, "http://www.miniprinter.com");
		// Print
		cpclPrinter.printForm();
    }
    
    public void barcode4(int count) throws UnsupportedEncodingException
    {
    	cpclPrinter.setForm(0, 200, 200, 670, count);
    	cpclPrinter.setMedia(paperType);
		cpclPrinter.setCPCLBarcode(0, 2, 0);
		// CODABAR
//		cpclPrinter.printCPCLBarcode(CPCLConst.AURES_CPCL_0_ROTATION, CPCLConst.AURES_CPCL_BCS_CODABAR, 2, CPCLConst.AURES_CPCL_BCS_0RATIO, 50, 209, 45, "A1234567890B", 0);
		// Code 39
		cpclPrinter.printCPCLBarcode(CPCLConst.AURES_CPCL_0_ROTATION, CPCLConst.AURES_CPCL_BCS_39, 2, CPCLConst.AURES_CPCL_BCS_1RATIO, 50, 115, 25, "01234567890", 0);
		// Code 93
		cpclPrinter.printCPCLBarcode(CPCLConst.AURES_CPCL_0_ROTATION, CPCLConst.AURES_CPCL_BCS_93, 2, CPCLConst.AURES_CPCL_BCS_1RATIO, 50, 160, 130, "01234567890", 0);
		// Code 128
		cpclPrinter.printCPCLBarcode(CPCLConst.AURES_CPCL_0_ROTATION, CPCLConst.AURES_CPCL_BCS_128, 2, CPCLConst.AURES_CPCL_BCS_1RATIO, 50, 209, 235, "01234567890", 0);
		// PDF 417
		cpclPrinter.printCPCL2DBarCode(0, CPCLConst.AURES_CPCL_BCS_PDF417, 200, 320, 3, 7, 2, 1, "SEWOO TECH\r\nLK-P11");
		// QRCODE
		cpclPrinter.printCPCL2DBarCode(0, CPCLConst.AURES_CPCL_BCS_QRCODE, 250, 410, 5, 0, 1, 0, "http://www.miniprinter.com");
		// Print
		cpclPrinter.printForm();
    }
    
    public void printAndroidFont(int count) throws UnsupportedEncodingException
	{
    	int nLineWidth = 832;
    	String data = "Receipt";

    	try
		{
    		cpclPrinter.setForm(0, 200, 200, 406, count);
    		cpclPrinter.setMedia(paperType);

    		cpclPrinter.printAndroidFont(data, nLineWidth, 100, 0, ESCPOSConst.AURES_ALIGNMENT_CENTER);
    		cpclPrinter.printAndroidFont("Left Alignment", nLineWidth, 24, 120, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		cpclPrinter.printAndroidFont("Center Alignment", nLineWidth, 24, 150, ESCPOSConst.AURES_ALIGNMENT_CENTER);
    		cpclPrinter.printAndroidFont("Right Alignment", nLineWidth, 24, 180, ESCPOSConst.AURES_ALIGNMENT_RIGHT);

    		cpclPrinter.printAndroidFont(Typeface.SANS_SERIF, "SANS_SERIF : 1234iwIW", nLineWidth, 24, 210, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		cpclPrinter.printAndroidFont(Typeface.SERIF, "SERIF : 1234iwIW", nLineWidth, 24, 240, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		cpclPrinter.printAndroidFont(Typeface.MONOSPACE, "MONOSPACE : 1234iwIW", nLineWidth, 24, 270, ESCPOSConst.AURES_ALIGNMENT_LEFT);

    		// Print
    		cpclPrinter.printForm();		
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}	

    public void printMultilingualFont(int count) throws UnsupportedEncodingException
	{
    	int nLineWidth = 832;
    	String Koreandata = "?��?���?";
    	String Turkishdata = "Turkish(İ,Ş,Ğ)";
    	String Russiandata = "?�олучени�?";
    	String Arabicdata = "ا?��??�صا�?";
    	String Greekdata = "?�αραλαβ�?";
    	String Japanesedata = "?��?��?��";
    	String GB2312data = "?��?��";
    	String BIG5data = "?��?��";

    	try
		{
    		cpclPrinter.setForm(0, 200, 200, 1000, count);
    		cpclPrinter.setMedia(paperType);

    		cpclPrinter.printAndroidFont("Korean Font", nLineWidth, 24, 0, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		// Korean 100-dot size font in android device.
    		cpclPrinter.printAndroidFont(Koreandata, nLineWidth, 100, 30, ESCPOSConst.AURES_ALIGNMENT_CENTER);

    		cpclPrinter.printAndroidFont("Turkish Font", nLineWidth, 24, 140, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		// Turkish 50-dot size font in android device.
    		cpclPrinter.printAndroidFont(Turkishdata, nLineWidth, 50, 170, ESCPOSConst.AURES_ALIGNMENT_CENTER);

    		cpclPrinter.printAndroidFont("Russian Font", nLineWidth, 24, 230, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		// Russian 60-dot size font in android device.
    		cpclPrinter.printAndroidFont(Russiandata, nLineWidth, 60, 260, ESCPOSConst.AURES_ALIGNMENT_CENTER);

    		cpclPrinter.printAndroidFont("Arabic Font", nLineWidth, 24, 330, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		// Arabic 100-dot size font in android device.
    		cpclPrinter.printAndroidFont(Arabicdata, nLineWidth, 100, 360, ESCPOSConst.AURES_ALIGNMENT_CENTER);

    		cpclPrinter.printAndroidFont("Greek Font", nLineWidth, 24, 470, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		// Greek 60-dot size font in android device.
    		cpclPrinter.printAndroidFont(Greekdata, nLineWidth, 60, 500, ESCPOSConst.AURES_ALIGNMENT_CENTER);

    		cpclPrinter.printAndroidFont("Japanese Font", nLineWidth, 24, 570, ESCPOSConst.AURES_ALIGNMENT_LEFT);
        	// Japanese 100-dot size font in android device.
    		cpclPrinter.printAndroidFont(Japanesedata, nLineWidth, 100, 600, ESCPOSConst.AURES_ALIGNMENT_CENTER);

    		cpclPrinter.printAndroidFont("GB2312 Font", nLineWidth, 24, 710, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		// GB2312 100-dot size font in android device.
    		cpclPrinter.printAndroidFont(GB2312data, nLineWidth, 100, 740, ESCPOSConst.AURES_ALIGNMENT_CENTER);

    		cpclPrinter.printAndroidFont("BIG5 Font", nLineWidth, 24, 850, ESCPOSConst.AURES_ALIGNMENT_LEFT);
    		// BIG5 100-dot size font in android device.
    		cpclPrinter.printAndroidFont(BIG5data, nLineWidth, 100, 880, ESCPOSConst.AURES_ALIGNMENT_CENTER);

    		// Print
    		cpclPrinter.printForm();		
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
