package com.aures.mobile.app.escpos;

import com.aures.jpos.command.ESCPOSConst;
import com.aures.mobile.app.assist.AlertView;
import com.aures.mobile.app.assist.ESCPSample2;

import android.app.ListActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.AdapterView.OnItemClickListener;

public class ESCP2Menu extends ListActivity
{
	private final String TAG = "Sample2";
	// Menu
	final static String[] arr = 
	{
		"Sample 1",
		"Barcode 2D",
		"Barcode 1D",
		"Image Test",
		"Print DataMatrix",
		"Print Android Font",
		"Print Multilingual"
	};
	
	@Override
	protected void onDestroy()
	{
//		Log.d(TAG,"onDestroy()");
		super.onDestroy();
	}
	
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setListAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1 , arr));
		getListView().setOnItemClickListener(new OnItemClickListener()
		{
			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3)
			{
				dialog(arg2);
			}
		});
	}
	
	// Dialog
	private void dialog(int arg1)
	{
		final int arg2 = arg1;
		int retval = 0;
		ESCPSample2 sample = new ESCPSample2();
		try
		{
			switch(arg2)
			{
				case 0:
					retval = sample.sample();
					break;
				case 1:
					retval = sample.barcode2d();
					break;
				case 2:
					retval = sample.barcodesample();
					break;
				case 3:
					retval = sample.imageTest();
					break;
				case 4:
					retval = sample.printDataMatrix();
					break;	
				case 5:
					retval = sample.printAndroidFont();
					break;
				case 6:
					retval = sample.printMultilingualFont();
					break;	
				default:
			}
		}
		catch(Exception e)
		{
			AlertView.showAlert(e.toString(), e.getMessage(), ESCP2Menu.this);
			Log.e(TAG,e.toString() +" "+ e.getMessage());
		}
		if(retval != ESCPOSConst.AURES_STS_NORMAL)
		{
			String msg = "";
			if(retval > 0)
			{
				if((ESCPOSConst.AURES_STS_BATTERY_LOW & retval)> 0)
					msg = "Battery Low\r\n";
				if((ESCPOSConst.AURES_STS_COVER_OPEN & retval) > 0)
					msg = msg + "Cover Open\r\n";
				if((ESCPOSConst.AURES_STS_MSR_READ & retval) > 0)
					msg = msg + "MSR Read status\r\n";
				if((ESCPOSConst.AURES_STS_PAPER_EMPTY & retval) > 0)
					msg = msg + "Paper Empty\r\n";
				// Show Status Error.
				AlertView.showAlert("Status Error",
						msg+" : "+retval, ESCP2Menu.this);
			} else {
				msg = msg + "Return value";
				// Printer check Error.
				AlertView.showAlert("Unknown Printer",
						msg+"="+retval, ESCP2Menu.this);
			}
		}
	}
}